Update 90-loaderentry* to systemd 254 and add support for loading additional images

This commit is contained in:
dalto 2023-08-27 15:40:13 -05:00
parent 56f8cfe6a5
commit de5c9bcd38
2 changed files with 100 additions and 72 deletions

View File

@ -16,46 +16,52 @@
# General Public License for more details. # General Public License for more details.
# #
# You should have received a copy of the GNU Lesser General Public License # You should have received a copy of the GNU Lesser General Public License
# along with systemd; If not, see <http://www.gnu.org/licenses/>. # along with systemd; If not, see <https://www.gnu.org/licenses/>.
COMMAND="$1" set -e
KERNEL_VERSION="$2"
ENTRY_DIR_ABS="$3" COMMAND="${1:?}"
KERNEL_VERSION="${2:?}"
ENTRY_DIR_ABS="${3:?}"
KERNEL_IMAGE="$4" KERNEL_IMAGE="$4"
INITRD_OPTIONS_SHIFT=4 INITRD_OPTIONS_SHIFT=4
[ "$KERNEL_INSTALL_LAYOUT" = "bls" ] || exit 0 [ "$KERNEL_INSTALL_LAYOUT" = "bls" ] || exit 0
MACHINE_ID="$KERNEL_INSTALL_MACHINE_ID" MACHINE_ID="${KERNEL_INSTALL_MACHINE_ID:?}"
ENTRY_TOKEN="$KERNEL_INSTALL_ENTRY_TOKEN" ENTRY_TOKEN="${KERNEL_INSTALL_ENTRY_TOKEN:?}"
BOOT_ROOT="$KERNEL_INSTALL_BOOT_ROOT" BOOT_ROOT="${KERNEL_INSTALL_BOOT_ROOT:?}"
BOOT_MNT="$(stat -c %m "$BOOT_ROOT")" [ -n "$BOOT_MNT" ] || BOOT_MNT="$(stat -c %m "$BOOT_ROOT")"
if [ "$BOOT_MNT" = '/' ]; then if [ "$BOOT_MNT" = '/' ]; then
ENTRY_DIR="$ENTRY_DIR_ABS" ENTRY_DIR="$ENTRY_DIR_ABS"
else else
ENTRY_DIR="${ENTRY_DIR_ABS#"$BOOT_MNT"}" ENTRY_DIR="${ENTRY_DIR_ABS#"$BOOT_MNT"}"
fi fi
KERNEL_DEST="$ENTRY_DIR_ABS/linux"
KERNEL_ENTRY="$ENTRY_DIR/linux"
LOADER_ENTRY="$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION.conf"
case "$COMMAND" in case "$COMMAND" in
remove) remove)
[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \ [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
echo "Removing $BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION*.conf" echo "Removing ${LOADER_ENTRY%.conf}*.conf"
exec rm -f \ exec rm -f \
"$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION.conf" \ "$LOADER_ENTRY" \
"$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION+"*".conf" "${LOADER_ENTRY%.conf}"*".conf"
;; ;;
add) add)
;; ;;
*) *)
exit 1 exit 0
;; ;;
esac esac
if [ -r /etc/os-release ]; then if [ -f /etc/os-release ]; then
# shellcheck source=/dev/null # shellcheck source=/dev/null
. /etc/os-release . /etc/os-release
elif [ -r /usr/lib/os-release ]; then elif [ -f /usr/lib/os-release ]; then
# shellcheck source=/dev/null # shellcheck source=/dev/null
. /usr/lib/os-release . /usr/lib/os-release
fi fi
@ -65,9 +71,13 @@ fi
SORT_KEY="$IMAGE_ID" SORT_KEY="$IMAGE_ID"
[ -z "$SORT_KEY" ] && SORT_KEY="$ID-$KERNEL_VERSION" [ -z "$SORT_KEY" ] && SORT_KEY="$ID-$KERNEL_VERSION"
if [ -r /etc/kernel/cmdline ]; then if [ -n "$KERNEL_INSTALL_CONF_ROOT" ]; then
if [ -f "$KERNEL_INSTALL_CONF_ROOT/cmdline" ]; then
BOOT_OPTIONS="$(tr -s "$IFS" ' ' <"$KERNEL_INSTALL_CONF_ROOT/cmdline")"
fi
elif [ -f /etc/kernel/cmdline ]; then
BOOT_OPTIONS="$(tr -s "$IFS" ' ' </etc/kernel/cmdline)" BOOT_OPTIONS="$(tr -s "$IFS" ' ' </etc/kernel/cmdline)"
elif [ -r /usr/lib/kernel/cmdline ]; then elif [ -f /usr/lib/kernel/cmdline ]; then
BOOT_OPTIONS="$(tr -s "$IFS" ' ' </usr/lib/kernel/cmdline)" BOOT_OPTIONS="$(tr -s "$IFS" ' ' </usr/lib/kernel/cmdline)"
else else
BOOT_OPTIONS="$(tr -s "$IFS" '\n' </proc/cmdline | grep -ve '^BOOT_IMAGE=' -e '^initrd=' | tr '\n' ' ')" BOOT_OPTIONS="$(tr -s "$IFS" '\n' </proc/cmdline | grep -ve '^BOOT_IMAGE=' -e '^initrd=' | tr '\n' ' ')"
@ -79,19 +89,19 @@ BOOT_OPTIONS="${BOOT_OPTIONS% }"
# command line with the machine ID we use, so that the machine ID remains # command line with the machine ID we use, so that the machine ID remains
# stable, even during factory reset, in the initrd (where the system's machine # stable, even during factory reset, in the initrd (where the system's machine
# ID is not directly accessible yet), and if the root file system is volatile. # ID is not directly accessible yet), and if the root file system is volatile.
if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ] && ! echo "$BOOT_OPTIONS" | grep -q "systemd.machine_id="; then
BOOT_OPTIONS="$BOOT_OPTIONS systemd.machine_id=$MACHINE_ID" BOOT_OPTIONS="$BOOT_OPTIONS systemd.machine_id=$MACHINE_ID"
fi fi
if [ -r /etc/kernel/tries ]; then TRIES_FILE="${KERNEL_INSTALL_CONF_ROOT:-/etc/kernel}/tries"
read -r TRIES </etc/kernel/tries
if [ -f "$TRIES_FILE" ]; then
read -r TRIES <"$TRIES_FILE"
if ! echo "$TRIES" | grep -q '^[0-9][0-9]*$'; then if ! echo "$TRIES" | grep -q '^[0-9][0-9]*$'; then
echo "/etc/kernel/tries does not contain an integer." >&2 echo "$TRIES_FILE does not contain an integer." >&2
exit 1 exit 1
fi fi
LOADER_ENTRY="$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION+$TRIES.conf" LOADER_ENTRY="${LOADER_ENTRY%.conf}+$TRIES.conf"
else
LOADER_ENTRY="$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION.conf"
fi fi
if ! [ -d "$ENTRY_DIR_ABS" ]; then if ! [ -d "$ENTRY_DIR_ABS" ]; then
@ -99,26 +109,31 @@ if ! [ -d "$ENTRY_DIR_ABS" ]; then
exit 1 exit 1
fi fi
install -g root -o root -m 0644 "$KERNEL_IMAGE" "$ENTRY_DIR_ABS/linux" || { install -m 0644 "$KERNEL_IMAGE" "$KERNEL_DEST" || {
echo "Error: could not copy '$KERNEL_IMAGE' to '$ENTRY_DIR_ABS/linux'." >&2 echo "Error: could not copy '$KERNEL_IMAGE' to '$KERNEL_DEST'." >&2
exit 1 exit 1
} }
chown root:root "$KERNEL_DEST" || :
shift "$INITRD_OPTIONS_SHIFT" shift "$INITRD_OPTIONS_SHIFT"
# All files listed as arguments, and staged files starting with "initrd" are installed as initrds. # All files listed as arguments, and staged files starting with "initrd" are installed as initrds.
for initrd in "$@" "${KERNEL_INSTALL_STAGING_AREA}"/initrd*; do for initrd in "${KERNEL_INSTALL_STAGING_AREA}"/microcode* "${@}" "${KERNEL_INSTALL_STAGING_AREA}"/initrd*; do
[ -f "$initrd" ] || { [ -f "$initrd" ] || {
[ "$initrd" = "${KERNEL_INSTALL_STAGING_AREA}/initrd*" ] && continue case "$initrd" in
echo "Error: initrd '$initrd' not a file." >&2 "${KERNEL_INSTALL_STAGING_AREA}/initrd*" | "${KERNEL_INSTALL_STAGING_AREA}/microcode*")
continue ;;
esac
echo "Error: '$initrd' is not a file." >&2
exit 1 exit 1
} }
initrd_basename="${initrd##*/}" initrd_basename="${initrd##*/}"
[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Installing $ENTRY_DIR_ABS/$initrd_basename" [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Installing $ENTRY_DIR_ABS/$initrd_basename"
install -g root -o root -m 0644 "$initrd" "$ENTRY_DIR_ABS/$initrd_basename" || { install -m 0644 "$initrd" "$ENTRY_DIR_ABS/$initrd_basename" || {
echo "Error: could not copy '$initrd' to '$ENTRY_DIR_ABS/$initrd_basename'." >&2 echo "Error: could not copy '$initrd' to '$ENTRY_DIR_ABS/$initrd_basename'." >&2
exit 1 exit 1
} }
chown root:root "$ENTRY_DIR_ABS/$initrd_basename" || :
done done
mkdir -p "${LOADER_ENTRY%/*}" || { mkdir -p "${LOADER_ENTRY%/*}" || {
@ -128,6 +143,8 @@ mkdir -p "${LOADER_ENTRY%/*}" || {
[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Creating $LOADER_ENTRY" [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Creating $LOADER_ENTRY"
{ {
echo "# Boot Loader Specification type#1 entry"
echo "# File created by $0 (systemd 254.1-1-arch)"
echo "title $PRETTY_NAME" echo "title $PRETTY_NAME"
echo "version $KERNEL_VERSION" echo "version $KERNEL_VERSION"
if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then
@ -136,10 +153,10 @@ mkdir -p "${LOADER_ENTRY%/*}" || {
fi fi
[ -n "$SORT_KEY" ] && echo "sort-key $SORT_KEY" [ -n "$SORT_KEY" ] && echo "sort-key $SORT_KEY"
echo "options $BOOT_OPTIONS" echo "options $BOOT_OPTIONS"
echo "linux $ENTRY_DIR/linux" echo "linux $KERNEL_ENTRY"
have_initrd= have_initrd=
for initrd in "${@}" "${KERNEL_INSTALL_STAGING_AREA}"/initrd*; do for initrd in "${KERNEL_INSTALL_STAGING_AREA}"/microcode* "${@}" "${KERNEL_INSTALL_STAGING_AREA}"/initrd* "${ENTRY_DIR_ABS}/initrd"; do
[ -f "$initrd" ] || continue [ -f "$initrd" ] || continue
echo "initrd $ENTRY_DIR/${initrd##*/}" echo "initrd $ENTRY_DIR/${initrd##*/}"
have_initrd=yes have_initrd=yes

View File

@ -16,52 +16,52 @@
# General Public License for more details. # General Public License for more details.
# #
# You should have received a copy of the GNU Lesser General Public License # You should have received a copy of the GNU Lesser General Public License
# along with systemd; If not, see <http://www.gnu.org/licenses/>. # along with systemd; If not, see <https://www.gnu.org/licenses/>.
COMMAND="$1" set -e
KERNEL_VERSION="$2"
ENTRY_DIR_ABS="$3" COMMAND="${1:?}"
KERNEL_VERSION="${2:?}"
ENTRY_DIR_ABS="${3:?}"
KERNEL_IMAGE="$4" KERNEL_IMAGE="$4"
INITRD_OPTIONS_SHIFT=4 INITRD_OPTIONS_SHIFT=4
[ "$KERNEL_INSTALL_LAYOUT" = "bls" ] || exit 0 [ "$KERNEL_INSTALL_LAYOUT" = "bls" ] || exit 0
# Read the optional config file for automation MACHINE_ID="${KERNEL_INSTALL_MACHINE_ID:?}"
[[ -f /etc/kernel-install-for-dracut.conf ]] && source /etc/kernel-install-for-dracut.conf ENTRY_TOKEN="${KERNEL_INSTALL_ENTRY_TOKEN:?}"
BOOT_ROOT="${KERNEL_INSTALL_BOOT_ROOT:?}"
MACHINE_ID="$KERNEL_INSTALL_MACHINE_ID" [ -n "$BOOT_MNT" ] || BOOT_MNT="$(stat -c %m "$BOOT_ROOT")"
ENTRY_TOKEN="$KERNEL_INSTALL_ENTRY_TOKEN"
BOOT_ROOT="$KERNEL_INSTALL_BOOT_ROOT"
BOOT_MNT="$(stat -c %m "$BOOT_ROOT")"
if [ "$BOOT_MNT" = '/' ]; then if [ "$BOOT_MNT" = '/' ]; then
ENTRY_DIR="$ENTRY_DIR_ABS" ENTRY_DIR="$ENTRY_DIR_ABS"
else else
ENTRY_DIR="${ENTRY_DIR_ABS#"$BOOT_MNT"}" ENTRY_DIR="${ENTRY_DIR_ABS#"$BOOT_MNT"}"
fi fi
KERNEL_DEST="$ENTRY_DIR_ABS/linux"
KERNEL_ENTRY="$ENTRY_DIR/linux"
LOADER_ENTRY="$BOOT_ROOT/loader/entries/${ENTRY_TOKEN}-${KERNEL_VERSION}-fallback.conf"
case "$COMMAND" in case "$COMMAND" in
remove) remove)
[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \ [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && \
echo "Removing $BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION-fallback*.conf" echo "Removing ${LOADER_ENTRY%.conf}*.conf"
exec rm -f \ exec rm -f \
"$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION-fallback.conf" \ "$LOADER_ENTRY" \
"$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION-fallback+"*".conf" 2> /dev/null || true "${LOADER_ENTRY%.conf}"*".conf"
;; ;;
add) add)
;; ;;
*) *)
exit 1 exit 0
;; ;;
esac esac
# Do nothing if the user has elected to omit the fallback initrd if [ -f /etc/os-release ]; then
[[ ${NO_DRACUT_FALLBACK} == "true" ]] && exit 0
if [ -r /etc/os-release ]; then
# shellcheck source=/dev/null # shellcheck source=/dev/null
. /etc/os-release . /etc/os-release
elif [ -r /usr/lib/os-release ]; then elif [ -f /usr/lib/os-release ]; then
# shellcheck source=/dev/null # shellcheck source=/dev/null
. /usr/lib/os-release . /usr/lib/os-release
fi fi
@ -69,13 +69,17 @@ fi
[ -n "$PRETTY_NAME" ] || PRETTY_NAME="Linux $KERNEL_VERSION" [ -n "$PRETTY_NAME" ] || PRETTY_NAME="Linux $KERNEL_VERSION"
SORT_KEY="$IMAGE_ID" SORT_KEY="$IMAGE_ID"
[ -z "$SORT_KEY" ] && SORT_KEY="$ID-$KERNEL_VERSION-fallback" [ -z "$SORT_KEY" ] && SORT_KEY="$ID-${KERNEL_VERSION}-fallback"
if [ -r /etc/kernel/cmdline_fb ]; then if [ -n "$KERNEL_INSTALL_CONF_ROOT" ]; then
if [ -f "$KERNEL_INSTALL_CONF_ROOT/cmdline" ]; then
BOOT_OPTIONS="$(tr -s "$IFS" ' ' <"$KERNEL_INSTALL_CONF_ROOT/cmdline")"
fi
elif [ -r /etc/kernel/cmdline_fb ]; then
BOOT_OPTIONS="$(tr -s "$IFS" ' ' </etc/kernel/cmdline_fb)" BOOT_OPTIONS="$(tr -s "$IFS" ' ' </etc/kernel/cmdline_fb)"
elif [ -r /etc/kernel/cmdline ]; then elif [ -f /etc/kernel/cmdline ]; then
BOOT_OPTIONS="$(tr -s "$IFS" ' ' </etc/kernel/cmdline)" BOOT_OPTIONS="$(tr -s "$IFS" ' ' </etc/kernel/cmdline)"
elif [ -r /usr/lib/kernel/cmdline ]; then elif [ -f /usr/lib/kernel/cmdline ]; then
BOOT_OPTIONS="$(tr -s "$IFS" ' ' </usr/lib/kernel/cmdline)" BOOT_OPTIONS="$(tr -s "$IFS" ' ' </usr/lib/kernel/cmdline)"
else else
BOOT_OPTIONS="$(tr -s "$IFS" '\n' </proc/cmdline | grep -ve '^BOOT_IMAGE=' -e '^initrd=' | tr '\n' ' ')" BOOT_OPTIONS="$(tr -s "$IFS" '\n' </proc/cmdline | grep -ve '^BOOT_IMAGE=' -e '^initrd=' | tr '\n' ' ')"
@ -87,19 +91,19 @@ BOOT_OPTIONS="${BOOT_OPTIONS% }"
# command line with the machine ID we use, so that the machine ID remains # command line with the machine ID we use, so that the machine ID remains
# stable, even during factory reset, in the initrd (where the system's machine # stable, even during factory reset, in the initrd (where the system's machine
# ID is not directly accessible yet), and if the root file system is volatile. # ID is not directly accessible yet), and if the root file system is volatile.
if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ] && ! echo "$BOOT_OPTIONS" | grep -q "systemd.machine_id="; then
BOOT_OPTIONS="$BOOT_OPTIONS systemd.machine_id=$MACHINE_ID" BOOT_OPTIONS="$BOOT_OPTIONS systemd.machine_id=$MACHINE_ID"
fi fi
if [ -r /etc/kernel/tries ]; then TRIES_FILE="${KERNEL_INSTALL_CONF_ROOT:-/etc/kernel}/tries"
read -r TRIES </etc/kernel/tries
if [ -f "$TRIES_FILE" ]; then
read -r TRIES <"$TRIES_FILE"
if ! echo "$TRIES" | grep -q '^[0-9][0-9]*$'; then if ! echo "$TRIES" | grep -q '^[0-9][0-9]*$'; then
echo "/etc/kernel/tries does not contain an integer." >&2 echo "$TRIES_FILE does not contain an integer." >&2
exit 1 exit 1
fi fi
LOADER_ENTRY="$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION-fallback+$TRIES.conf" LOADER_ENTRY="${LOADER_ENTRY%.conf}+$TRIES.conf"
else
LOADER_ENTRY="$BOOT_ROOT/loader/entries/$ENTRY_TOKEN-$KERNEL_VERSION-fallback.conf"
fi fi
if ! [ -d "$ENTRY_DIR_ABS" ]; then if ! [ -d "$ENTRY_DIR_ABS" ]; then
@ -107,26 +111,31 @@ if ! [ -d "$ENTRY_DIR_ABS" ]; then
exit 1 exit 1
fi fi
install -g root -o root -m 0644 "$KERNEL_IMAGE" "$ENTRY_DIR_ABS/linux" || { install -m 0644 "$KERNEL_IMAGE" "$KERNEL_DEST" || {
echo "Error: could not copy '$KERNEL_IMAGE' to '$ENTRY_DIR_ABS/linux'." >&2 echo "Error: could not copy '$KERNEL_IMAGE' to '$KERNEL_DEST'." >&2
exit 1 exit 1
} }
chown root:root "$KERNEL_DEST" || :
shift "$INITRD_OPTIONS_SHIFT" shift "$INITRD_OPTIONS_SHIFT"
# All files listed as arguments, and staged files starting with "initrd-fallback" are installed as initrds. # All files listed as arguments, and staged files starting with "initrd" are installed as initrds.
for initrd in "$@" "${KERNEL_INSTALL_STAGING_AREA}"/initrd-fallback*; do for initrd in "${KERNEL_INSTALL_STAGING_AREA}"/microcode* "${@}" "${KERNEL_INSTALL_STAGING_AREA}"/initrd*; do
[ -f "$initrd" ] || { [ -f "$initrd" ] || {
[ "$initrd" = "${KERNEL_INSTALL_STAGING_AREA}/initrd-fallback*" ] && continue case "$initrd" in
echo "Error: initrd '$initrd' not a file." >&2 "${KERNEL_INSTALL_STAGING_AREA}/initrd*" | "${KERNEL_INSTALL_STAGING_AREA}/microcode*")
continue ;;
esac
echo "Error: '$initrd' is not a file." >&2
exit 1 exit 1
} }
initrd_basename="${initrd##*/}" initrd_basename="${initrd##*/}"
[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Installing $ENTRY_DIR_ABS/$initrd_basename" [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Installing $ENTRY_DIR_ABS/$initrd_basename"
install -g root -o root -m 0644 "$initrd" "$ENTRY_DIR_ABS/$initrd_basename" || { install -m 0644 "$initrd" "$ENTRY_DIR_ABS/$initrd_basename" || {
echo "Error: could not copy '$initrd' to '$ENTRY_DIR_ABS/$initrd_basename'." >&2 echo "Error: could not copy '$initrd' to '$ENTRY_DIR_ABS/$initrd_basename'." >&2
exit 1 exit 1
} }
chown root:root "$ENTRY_DIR_ABS/$initrd_basename" || :
done done
mkdir -p "${LOADER_ENTRY%/*}" || { mkdir -p "${LOADER_ENTRY%/*}" || {
@ -136,18 +145,20 @@ mkdir -p "${LOADER_ENTRY%/*}" || {
[ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Creating $LOADER_ENTRY" [ "$KERNEL_INSTALL_VERBOSE" -gt 0 ] && echo "Creating $LOADER_ENTRY"
{ {
echo "# Boot Loader Specification type#1 entry"
echo "# File created by $0 (systemd 254.1-1-arch)"
echo "title $PRETTY_NAME" echo "title $PRETTY_NAME"
echo "version $KERNEL_VERSION-fallback" echo "version ${KERNEL_VERSION}-fallback"
if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then if [ "$ENTRY_TOKEN" = "$MACHINE_ID" ]; then
# See similar logic above for the systemd.machine_id= kernel command line option # See similar logic above for the systemd.machine_id= kernel command line option
echo "machine-id $MACHINE_ID" echo "machine-id $MACHINE_ID"
fi fi
[ -n "$SORT_KEY" ] && echo "sort-key $SORT_KEY" [ -n "$SORT_KEY" ] && echo "sort-key $SORT_KEY"
echo "options $BOOT_OPTIONS" echo "options $BOOT_OPTIONS"
echo "linux $ENTRY_DIR/linux" echo "linux $KERNEL_ENTRY"
have_initrd= have_initrd=
for initrd in "${@}" "${KERNEL_INSTALL_STAGING_AREA}"/initrd-fallback*; do for initrd in "${KERNEL_INSTALL_STAGING_AREA}"/microcode* "${@}" "${KERNEL_INSTALL_STAGING_AREA}"/initrd* "${ENTRY_DIR_ABS}/initrd-fallback"; do
[ -f "$initrd" ] || continue [ -f "$initrd" ] || continue
echo "initrd $ENTRY_DIR/${initrd##*/}" echo "initrd $ENTRY_DIR/${initrd##*/}"
have_initrd=yes have_initrd=yes